name: ci

on:
    push:
    pull_request:
    schedule:
        - cron: '0 0 * * 0' # weekly

jobs:
    build:
        runs-on: ubuntu-latest
        name: "python ${{ matrix.python-version }} xcbver ${{ matrix.xcbver }}"
        strategy:
            fail-fast: false
            matrix:
                python-version: [3.8, 3.9, "3.10", "3.11", "pypy3.9"]
                xcbver: [xcb-proto-1.14.1, xcb-proto-1.15.2, xcb-proto-1.16.0, master]
        steps:
            - uses: actions/checkout@v3
            - name: Set up python "${{ matrix.python-version }}"
              uses: actions/setup-python@v4
              with:
                  python-version: "${{ matrix.python-version }}"
            - uses: haskell/actions/setup@v2
              with:
                  ghc-version: '9.2'
                  cabal-version: latest
            - run: cabal update
            - run: sudo apt install x11-apps python3-pytest python3-cffi flake8
            - run: git clone https://gitlab.freedesktop.org/xorg/proto/xcbproto.git proto && cd proto && git checkout ${{ matrix.xcbver }}
            - run: make XCBDIR=./proto/src check
